#include<bits/stdc++.h>
using namespace std;
int main()
{
    int t;
    cin >> t;
    for(int i=0;i<t;i++ )
    {
        int n,m;
        long long a[75001];
        long long b[75001];
        cin >> n >> m;
        for(int j =0;j<n;j++)
        {
            cin >> a[j];
        }
        for(int j =0;j<m;j++)
        {
            cin >> b[j];
        }
        long long min1= a[0];
        for(int j =1;j<n;j++)
        {
            if(a[j]<min1)
            {
                min1=a[j];
                long long c = a[j];
                a[j]=a[0];
                a[0]=c;
            }
        }
        for(int j=1;j<n;j++)
        {
            a[j]-=min1;
        }
        long long res=a[1];
        for(int j =2;j<n;j++)
        {
            res=__gcd(res,a[j]);
        }
        for(int j =0;j<m;j++)
        {
            b[j]-=min1;
        }
        int rez=1;
        for(int j =0;j<m;j++)
        {
            if(b[j]%res==0)
            {
              rez=0;
              break;
            }
        }
        cout << rez<<endl;
    }
}